--[[ ExtraActionButton
     Move the ExtraActionButton1 on ExtraActionBarFrame around
     http://www.wowinterface.com/forums/showthread.php?p=248734#post248734
  ]]

if not FixR then return end

local M = FixR:NewModule("ExtraActionButton")

local EABFrame = nil
local EABFrameEvents = {};
local moving = false

function EABFrameEvents:UPDATE_EXTRA_ACTIONBAR(...)
  if HasExtraActionBar() then
    ExtraActionButton1.style:SetTexture(nil)
  end
end

function M:Load()
  if EABFrame == nil then --create Frame if does not already exist
    EABFrame = CreateFrame("Frame", "EABFrame", UIParent)
    EABFrame:SetPoint(M.O["framePoint"], M.O["frameRelativeTo"], M.O["frameRelativePoint"], M.O["frameOffsetX"], M.O["frameOffsetY"])
    EABFrame:SetFrameStrata("HIGH")
    EABFrame:SetSize(40, 40)
    
    --blue background
    EABFrame.texture = EABFrame:CreateTexture()
    EABFrame.texture:SetAllPoints(EABFrame)
    EABFrame.texture:SetTexture(0.67, 0.67, 1, 0.01)
    
    EABFrame:SetScript("OnEvent", function(self, event, ...)
      EABFrameEvents[event](self, ...); -- call one of the functions above
    end);
    EABFrame:SetScript("OnDragStart", function(self) self:StartMoving(); end);
    EABFrame:SetScript("OnDragStop", function(self)
      self:StopMovingOrSizing()
      point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint()
      M.O["framePoint"] = point or "CENTER"
      M.O["frameRelativeTo"] = relativeTo or "UIParent"
      M.O["frameRelativePoint"] = relativePoint or "CENTER"
      M.O["frameOffsetX"] = FixR:Round(xOfs, 4)
      M.O["frameOffsetY"] = FixR:Round(yOfs, 4)
    end);
    
    --[[
    EABFrame:EnableMouse(true)
    EABFrame:SetScript("OnMouseUp", function(self, button, ...)
      if button == "MiddleButton" then
        --self:SetSize(20, 20) -- protected
        --self:Hide() -- protected
        --self:EnableMouse(false) -- protected
        --self:SetFrameStrata("BACKGROUND") -- protected
        --/run EABFrame:SetFrameStrata("HIGH")
      end
    end);
    --]]
    
  end
  
  for k, v in pairs(EABFrameEvents) do
    EABFrame:RegisterEvent(k); -- Register all events for which handlers have been defined
  end
  
  local f = ExtraActionBarFrame
  f:SetParent(EABFrame)
  f:ClearAllPoints()
  f:SetPoint("CENTER", 0, 0)
  f.ignoreFramePositionManager = true
  
  ExtraActionButton1.style:SetTexture(nil)
  ExtraActionButton1:SetSize(40, 40) --original button size: 52x52
  
  EABFrame:Show()
  
end
function M:Unload()
  if EABFrame then
    for k, v in pairs(EABFrameEvents) do
      EABFrame:UnregisterEvent(k); -- Unregister all events for which handlers have been defined
    end
    EABFrame:Hide()
  end
end

function M:SetOption(o)
  if o == "move" then
    if moving then
      moving = false
      EABFrame.texture:SetTexture(0.67, 0.67, 1, 0.01) -- cannot :Hide() in combat, so make it nearly transparent
      EABFrame:SetMovable(false) --click-through
      EABFrame:EnableMouse(false)
      EABFrame:RegisterForDrag("")
    else
      moving = true
      EABFrame.texture:SetTexture(0.67, 0.67, 1, 1) --opaque
      EABFrame:SetMovable(true);
      EABFrame:EnableMouse(true);
      EABFrame:RegisterForDrag("LeftButton");
    end
    FixR:Echo("ExtraActionButton: now "..(moving and "moving" or "fixed"))
  elseif o == "reset" then
    M.O["framePoint"] = M.DefaultO["framePoint"]
    M.O["frameRelativeTo"] = M.DefaultO["frameRelativeTo"]
    M.O["frameRelativePoint"] = M.DefaultO["frameRelativePoint"]
    M.O["frameOffsetX"] = M.DefaultO["frameOffsetX"]
    M.O["frameOffsetY"] = M.DefaultO["frameOffsetY"]
    
    EABFrame:SetPoint(M.O["framePoint"], M.O["frameRelativeTo"], M.O["frameRelativePoint"], M.O["frameOffsetX"], M.O["frameOffsetY"])
  end
end
function M:ShowOptions()
  FixR:Echo("  ExtraActionButton move: toggle moving the frame")
  FixR:Echo("  ExtraActionButton reset: reset the frame's position")
end