--[[ Inspect
     Get more information about the inspected unit
  ]]

if not FixR then return end

local M = FixR:NewModule("Inspect")

function M:Load()
  QueueStatusFrame:ClearAllPoints()
  QueueStatusFrame:SetPoint("BOTTOMLEFT", QueueStatusMinimapButton, "TOPRIGHT")
end

function M:Unload()
  QueueStatusFrame:ClearAllPoints()
  QueueStatusFrame:SetPoint("TOPRIGHT", QueueStatusMinimapButton, "BOTTOMLEFT")
end

local InspectFrame = nil
local InspectFrameEvents = {};
local waitingForInspect = false
local waitingForStatistics = false
--local fixRInspect_waitingFlags = 0x0 --0b0001: equipped items, 0b0010: statistics
local function IsKill(str)
  return (str ~= "--")
end
local function IncreaseIfKill(val, str)
  if str == "--" then
    return (val)
  end
  return (val+1)
end
local function getAvgItemlevelOfUnit(unit)
  local slotid, itemid, levelaccum, itemcount, levelavg = 0, 0, 0, 0, 0
  local missedSlots = 0
  --HeadSlot: 1, NeckSlot: 2, ShoulderSlot: 3
  --ChestSlot: 5, WaistSlot: 6, LegsSlot: 7, FeetSlot: 8, WristSlot: 9, HandsSlot: 10, Finger0Slot: 11, Finger1Slot: 12, Trinket0Slot: 13, Trinket1Slot: 14, BackSlot: 15, MainHandSlot: 16, SecondaryHandSlot: 17, RangedSlot: 18
  for slotid = 1, 3, 1 do
    --itemid = GetInventoryItemID(unit, slotid)
    local itemlink = GetInventoryItemLink(unit, slotid)
    --if itemid ~= nil then
    if itemlink then
      --local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(itemid)
      local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(itemlink)
      itemcount = itemcount + 1
      levelaccum = levelaccum + iLevel
    else
      missedSlots = missedSlots + 1
    end
  end
  --for slotid = 5, 18, 1 do
  for slotid = 5, 17, 1 do
    --itemid = GetInventoryItemID(unit, slotid)
    local itemlink = GetInventoryItemLink(unit, slotid)
    --if itemid ~= nil then
    if itemlink then
      --local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(itemid)
      local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(itemlink)
      itemcount = itemcount + 1
      levelaccum = levelaccum + iLevel
    else
      missedSlots = missedSlots + 1
    end
  end
  if itemcount > 0 then
    levelavg = levelaccum / itemcount
  end
  if missedSlots > 0 then
    FixR:Echo("  inspect missed: "..missedSlots.." slots!")
  end
  return levelavg
end

--[[
local function bit(p)
  return 2 ^ (p - 1)  -- 1-based indexing
end
-- Typical call:  if hasbit(x, bit(3)) then ...
local function hasbit(x, p)
  return x % (p + p) >= p       
end
local function setbit(x, p)
  return hasbit(x, p) and x or x + p
end
local function clearbit(x, p)
  return hasbit(x, p) and x - p or x
end
--]]

function InspectFrameEvents:INSPECT_READY(...)
  --if hasbit(fixRInspect_waitingFlags, bit(1)) then
  if waitingForInspect then
    waitingForInspect = false
    --fixRInspect_waitingFlags = clearbit(fixRInspect_waitingFlags, bit(1))
    local specID = GetInspectSpecialization("target")
    if specID > 0 then
      local id, name, description, icon, background, role = GetSpecializationInfoByID(specID)
      FixR:Echo("  Spec:")
      FixR:Echo("  - "..name.." ("..role..")")
    end
  end
end
function InspectFrameEvents:INSPECT_ACHIEVEMENT_READY(...)
  --if hasbit(fixRInspect_waitingFlags, bit(2)) then
  if waitingForStatistics then
    --fixRInspect_waitingFlags = clearbit(fixRInspect_waitingFlags, bit(2))
    waitingForStatistics = false
    
    -- Firelands
    local progress_FLN = 0
    local progress_FLH = 0
    --http://www.wowpedia.org/API_GetStatistic
    --http://www.wowwiki.com/API_GetStatistic
    local kills_FL_BethN = GetComparisonStatistic(5964)
    progress_FLN = IncreaseIfKill(progress_FLN, kills_FL_BethN)
    local kills_FL_BethH = GetComparisonStatistic(5965)
    progress_FLH = IncreaseIfKill(progress_FLH, kills_FL_BethH)
    local kills_FL_RhyoN = GetComparisonStatistic(5966)
    progress_FLN = IncreaseIfKill(progress_FLN, kills_FL_RhyoN)
    local kills_FL_RhyoH = GetComparisonStatistic(5967)
    progress_FLH = IncreaseIfKill(progress_FLH, kills_FL_RhyoH)
    local kills_FL_ShanN = GetComparisonStatistic(5968)
    progress_FLN = IncreaseIfKill(progress_FLN, kills_FL_ShanN)
    local kills_FL_ShanH = GetComparisonStatistic(5969)
    progress_FLH = IncreaseIfKill(progress_FLH, kills_FL_ShanH)
    local kills_FL_AlysN = GetComparisonStatistic(5970)
    progress_FLN = IncreaseIfKill(progress_FLN, kills_FL_AlysN)
    local kills_FL_AlysH = GetComparisonStatistic(5971)
    progress_FLH = IncreaseIfKill(progress_FLH, kills_FL_AlysH)
    local kills_FL_BaleN = GetComparisonStatistic(5972)
    progress_FLN = IncreaseIfKill(progress_FLN, kills_FL_BaleN)
    local kills_FL_BaleH = GetComparisonStatistic(5973)
    progress_FLH = IncreaseIfKill(progress_FLH, kills_FL_BaleH)
    local kills_FL_MajoN = GetComparisonStatistic(5974)
    progress_FLN = IncreaseIfKill(progress_FLN, kills_FL_MajoN)
    local kills_FL_MajoH = GetComparisonStatistic(5975)
    progress_FLH = IncreaseIfKill(progress_FLH, kills_FL_MajoH)
    local kills_FL_RagnN = GetComparisonStatistic(5976)
    progress_FLN = IncreaseIfKill(progress_FLN, kills_FL_RagnN)
    local kills_FL_RagnH = GetComparisonStatistic(5977)
    progress_FLH = IncreaseIfKill(progress_FLH, kills_FL_RagnH)
    
    --Dragon Soul
    local progress_DSN = 0
    local progress_DSH = 0
    
    local kills_DS_MorcN = GetComparisonStatistic(6153)
    progress_DSN = IncreaseIfKill(progress_DSN, kills_DS_MorcN)
    local kills_DS_MorcH = GetComparisonStatistic(6154)
    progress_DSH = IncreaseIfKill(progress_DSH, kills_DS_MorcH)
    local kills_DS_ZonoN = GetComparisonStatistic(6155)
    progress_DSN = IncreaseIfKill(progress_DSN, kills_DS_ZonoN)
    local kills_DS_ZonoH = GetComparisonStatistic(6156)
    progress_DSH = IncreaseIfKill(progress_DSH, kills_DS_ZonoH)
    local kills_DS_YorsN = GetComparisonStatistic(6157)
    progress_DSN = IncreaseIfKill(progress_DSN, kills_DS_YorsN)
    local kills_DS_YorsH = GetComparisonStatistic(6158)
    progress_DSH = IncreaseIfKill(progress_DSH, kills_DS_YorsH)
    local kills_DS_HagaN = GetComparisonStatistic(6159)
    progress_DSN = IncreaseIfKill(progress_DSN, kills_DS_HagaN)
    local kills_DS_HagaH = GetComparisonStatistic(6160)
    progress_DSH = IncreaseIfKill(progress_DSH, kills_DS_HagaH)
    local kills_DS_UltrN = GetComparisonStatistic(6161)
    progress_DSN = IncreaseIfKill(progress_DSN, kills_DS_UltrN)
    local kills_DS_UltrH = GetComparisonStatistic(6162)
    progress_DSH = IncreaseIfKill(progress_DSH, kills_DS_UltrH)
    local kills_DS_BlacN = GetComparisonStatistic(6163)
    progress_DSN = IncreaseIfKill(progress_DSN, kills_DS_BlacN)
    local kills_DS_BlacH = GetComparisonStatistic(6164)
    progress_DSH = IncreaseIfKill(progress_DSH, kills_DS_BlacH)
    local kills_DS_SpinN = GetComparisonStatistic(6165)
    progress_DSN = IncreaseIfKill(progress_DSN, kills_DS_SpinN)
    local kills_DS_SpinH = GetComparisonStatistic(6166)
    progress_DSH = IncreaseIfKill(progress_DSH, kills_DS_SpinH)
    local kills_DS_DeatN = GetComparisonStatistic(6167)
    progress_DSN = IncreaseIfKill(progress_DSN, kills_DS_DeatN)
    local kills_DS_DeatH = GetComparisonStatistic(6168)
    progress_DSH = IncreaseIfKill(progress_DSH, kills_DS_DeatH)
    
    FixR:Echo("  Progress:")
    FixR:Echo("  - FL: "..progress_FLN.."/7 nHC "..progress_FLH.."/7 HC")
    FixR:Echo("  - DS: "..progress_DSN.."/8 nHC "..progress_DSH.."/8 HC")
    
    ClearAchievementComparisonUnit()
  end
end

function M:Load()
  if InspectFrame == nil then
    InspectFrame = CreateFrame("Frame")
    InspectFrame:SetScript("OnEvent", function(self, event, ...)
      InspectFrameEvents[event](self, ...); -- call one of the functions above
    end);
  end
  for k, v in pairs(InspectFrameEvents) do
    InspectFrame:RegisterEvent(k); -- Register all events for which handlers have been defined
  end
end
function M:Unload()
  if InspectFrame then
    for k, v in pairs(InspectFrameEvents) do
      InspectFrame:UnregisterEvent(k); -- Unregister all events for which handlers have been defined
    end
  end
end

function M:SetOption(o)
  --print("testmodul SetOption "..arg1)
  --FixR:Echo(...)
  --M.O["option1"] = arg1..arg2
  if o == "inspect" then
    local inRange = CheckInteractDistance("target", 1); -- 1 = Inspect, 28 yards
    local canInspect = CanInspect("target")
    if inRange and canInspect then
      local name, realm = UnitName("target")
      name = name or "Unknown"
      if realm then
        name = name.." - "..realm
      end
      FixR:Echo("Scanning "..name..":")
      --fixRInspect_waitingFlags = 0x3
      waitingForStatistics = true
      SetAchievementComparisonUnit("target")
      --waitingForInspect = true
      --NotifyInspect("target")
    else
      FixR:Echo("out of range")
    end
  elseif o == "talents" then --/fixr inspect talents
    --[ [
    local inRange = CheckInteractDistance("target", 1); -- 1 = Inspect, 28 yards
    local canInspect = CanInspect("target")
    if inRange and canInspect then
      local playerName, realm = UnitName("target")
      playerName = playerName or "Unknown"
      if realm then
        playerName = playerName.." - "..realm
      end
      --local role, maxPoints = "unknown", 0
      --local numTabs = GetNumTalentTabs(true); --GetNumTalentTabs -> GetNumSpecializations
      --print("numTabs:", numTabs)
      --for t=1, numTabs do
      --  local id, name, desc, _, pointsSpent = GetTalentTabInfo(t, true)
      --  --DEFAULT_CHAT_FRAME:AddMessage("#"..id..", "..name.." ("..desc..") "..pointsSpent.." points spent:");
      --  if pointsSpent > maxPoints then
      --    maxPoints = pointsSpent
      --    role = name
      --  end
        --local numTalents = GetNumTalents(t, true);
        --for i=1, numTalents do
        --  local nameTalent, icon, tier, column, currRank, maxRank = GetTalentInfo(t, i, true);
        --  DEFAULT_CHAT_FRAME:AddMessage("- "..nameTalent..": "..currRank.."/"..maxRank);
        --end
      --end
      --FixR:Echo("Role of "..playerName..": "..role)
      if FixR:IsMop() then
        FixR:Echo("Scanning "..playerName..":")
        waitingForInspect = true
        NotifyInspect("target")
      else
        FixR:Echo("This feature is not supported in the Cataclysm client.")
      end
    else
      FixR:Echo("Cannot inspect.")
    end
    --]]
  end
end
  
-- stat # 5981 Occu'thar kills (Baradin Hold) 0 false nil nil nil  1 Interface\Icons\Trade_Engineering 
-- stat # 6150 Murozond kills (End Time) 0 false nil nil nil  1 Interface\Icons\achievement_boss_infinitecorruptor 
-- stat # 6151 Mannoroth defeats (Well of Eternity) 0 false nil nil nil  1 Interface\Icons\achievment_boss_wellofeternity 
-- stat # 6152 Archbishop Benedictus kills (Hour of Twilight) 0 false nil nil nil  1 Interface\Icons\achievment_raid_houroftwilight 
-- stat # 6170 Alizabal kills (Baradin Hold) 0 false nil nil nil  1 Interface\Icons\Trade_Engineering 

--/run SetAchievementComparisonUnit("target")
--fire INSPECT_ACHIEVEMENT_READY
--/run print(GetComparisonStatistic(6170))
--/run ClearAchievementComparisonUnit()